/**
 * 1Gb API
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import request = require('request');
import http = require('http');
import Promise = require('bluebird');

let defaultBasePath = 'https://www.1gb.ru/api';

// ===============================================
// This file is autogenerated - Please do not edit
// ===============================================

/* tslint:disable:no-unused-variable */

export class InlineResponse200 {
    /**
    * Планируемое количество дней до наступления негативного баланса
    */
    'negativeBalanceDays': number;
    /**
    * Планируемое количество дней до наступления негативного баланса по аккаунту лицензий
    */
    'negativeBalanceDaysLic': number;
    /**
    * 
    */
    'lastMonthDebtSum': number;
    /**
    * 
    */
    'lastMonthDebtSum2': number;
    /**
    * Дата блокировки аккаунта
    */
    'blockDate': string;
}

export class InlineResponse2001 {
    /**
    * Идентификатор аккаунта
    */
    'id': number;
    /**
    * Описание аккаунта
    */
    'description': string;
    /**
    * Идентификатор тарифной группы
    */
    'billingGroupId': number;
    /**
    * Аккаунт заблокирован, если true
    */
    'blocked': string;
    /**
    * Дата блокировки
    */
    'blockedDate': string;
    /**
    * Причина блокировки
    */
    'blockedReason': string;
    /**
    * Ограничение суммы на работу в аванс
    */
    'creditLimit': number;
    /**
    * Идентификатор тарифа
    */
    'planId': number;
    /**
    * Идентификатор тарифа (периода)
    */
    'periodId': number;
    /**
    * Тип договора
    */
    'contractType': number;
    /**
    * 
    */
    'clientId': number;
    /**
    * Логин клиента
    */
    'clientLogin': string;
    /**
    * Номер договора
    */
    'contractId': string;
    /**
    * Имя клиента на русском
    */
    'nameRus': string;
    /**
    * Имя клиента на английском
    */
    'nameEng': string;
    /**
    * E-mail клиент
    */
    'email': string;
    /**
    * Количество созданных сайтов
    */
    'statSites': number;
    /**
    * Используемое дисковое пространство
    */
    'statSizeMb': number;
    /**
    * Количество созданных почтовых ящиков
    */
    'statEmails': number;
    /**
    * Количество баз данных MySQL
    */
    'statMysqls': number;
    /**
    * 
    */
    'statTech': number;
    /**
    * 
    */
    'statNicd': number;
    /**
    * 
    */
    'statAccessDynamic': number;
    /**
    * 
    */
    'statAccessStatic': number;
    /**
    * 
    */
    'statAccessTraffic': number;
    /**
    * 
    */
    'statPaidTotal': number;
    /**
    * Размер дисков VDS
    */
    'statVdsSize': number;
    /**
    * Название тарифного плана
    */
    'planName': string;
    /**
    * Количество месяцев в оплаченном периоде
    */
    'periodMonths': number;
    /**
    * Стоимость оплаченного периода
    */
    'periodPrice': number;
    /**
    * 
    */
    'expires': string;
    /**
    * Префикс для вывода текущей валюты хостинга (например, в строке '$100' префиксом является '$')
    */
    'externalCurrencySpelledPrefix': string;
    /**
    * Суффикс для вывода текущей валюты хостинга (например, в строке '100 руб.' суффиксом является ' руб.'
    */
    'externalCurrencySpelledSuffix': string;
}

export class InlineResponse20010 {
    /**
    * Идентификатор записи
    */
    'id': number;
    /**
    * Дата и время создания записи
    */
    'datetime': string;
    /**
    * Тело сообщения (с HTML-тэгами)
    */
    'description': string;
    /**
    * Тело сообщения (без тэгов)
    */
    'descriptionPlain': string;
}

export class InlineResponse20011 {
    /**
    * IP-адрес
    */
    'ip': string;
    /**
    * идентификатор VDS
    */
    'vdsId': number;
}

export class InlineResponse20012 {
    /**
    * идентификатор VDS
    */
    'id': number;
    /**
    * VDS удалён если true
    */
    'deleted': boolean;
    /**
    * VDS работает нормально если true
    */
    'online': boolean;
    /**
    * VDS остановлен если true
    */
    'stopped': boolean;
    /**
    * изначальный пароль администратора или root
    */
    'pwd': string;
    /**
    * шаблон, на основе которого был создан VDS
    */
    'template': string;
    /**
    * полное описание типа VDS
    */
    'typeFull': string;
    /**
    * MAC-адрес VDS
    */
    'physicalMac': string;
    /**
    * тип VDS
    */
    'type': string;
}

export class InlineResponse20013 {
    /**
    * Тип VDS, для которого применим шаблон. Принимает значения 'hv' и 'vz'
    */
    'type': string;
    /**
    * Имя шаблона
    */
    'template': string;
    /**
    * Популярность
    */
    'popularity': number;
    /**
    * Актуальность шаблона. 1 = шаблон актуален
    */
    'actualTemplate': number;
}

export class InlineResponse20014 {
    /**
    * 
    */
    'id': number;
    /**
    * 
    */
    'status': string;
    /**
    * 
    */
    'unmovable': string;
    /**
    * Включен (активен), если true.
    */
    'online': string;
    /**
    * Удален, если true. Данные могут сохраняться.
    */
    'deleted': string;
    /**
    * Удален, если true. Данные могут сохраняться.
    */
    'deletedAuto': string;
    /**
    * 
    */
    'deletedDump': string;
    /**
    * 
    */
    'userId': string;
    /**
    * 
    */
    'ftpId': string;
    /**
    * 
    */
    'dnsId': string;
    /**
    * 
    */
    'iisId': string;
    /**
    * 
    */
    'iisBinding': string;
    /**
    * 
    */
    'iisPath': string;
    /**
    * Уникальное строковое имя сайта (ID).
    */
    'iisComments': string;
    /**
    * 
    */
    'memo': string;
    /**
    * Дата создания.
    */
    'dateReg': string;
    /**
    * Тип веб-сервера.
    */
    'server': string;
    /**
    * 
    */
    'serverBak': string;
    /**
    * 
    */
    'serverAux': string;
    /**
    * Тип сервера недавно изменялся, если true.
    */
    'serverTransition': string;
    /**
    * 
    */
    'serverTransitionDtc': string;
    /**
    * 
    */
    'blockTransfer': string;
    /**
    * 
    */
    'serverChangedTime': string;
    /**
    * Размер веб-сайта - объем (Кб).
    */
    'sizeAmount': string;
    /**
    * Размер веб-сайта - кол-во файлов.
    */
    'sizeFileCount': string;
    /**
    * 
    */
    'sizeFileCountLimit': string;
    /**
    * Размер веб-сайта - дата замера.
    */
    'sizeDate': string;
    /**
    * 
    */
    'sizePriorityScan': string;
    /**
    * 
    */
    'copyLogs': string;
    /**
    * 
    */
    'contentComments': string;
    /**
    * 
    */
    'contentCommentsVerbose': string;
    /**
    * 
    */
    'metaSaveCount': string;
    /**
    * 
    */
    'baseFolder': string;
    /**
    * 
    */
    'virtualhostConf': string;
    /**
    * 
    */
    'virtualhostServer': string;
    /**
    * 
    */
    'virtualhostServerConf': string;
    /**
    * 
    */
    'liveDayCount': string;
    /**
    * 
    */
    'scanDate': string;
    /**
    * 
    */
    'globalTransferCount': string;
    /**
    * 
    */
    'netLimitFile': string;
    /**
    * 
    */
    'netLimitDenyFromIp': string;
    /**
    * 
    */
    'netLimitDenyFromAgent': string;
    /**
    * 
    */
    'apachePhpPooled': string;
    /**
    * 
    */
    'apachePhpPooledExt': string;
    /**
    * 
    */
    'apachePhpPooledExtAuto': string;
    /**
    * 
    */
    'apachePhpPool1Only': string;
    /**
    * 
    */
    'apachePhpPool5Only': string;
    /**
    * 
    */
    'apacheSsi': string;
    /**
    * 
    */
    'bypassSecurity': string;
    /**
    * 
    */
    'flagGenericExec': string;
    /**
    * 
    */
    'flagNoWww': string;
    /**
    * 
    */
    'baseFolderSuffix': string;
    /**
    * 
    */
    'feedbackSpeed': string;
    /**
    * 
    */
    'feedbackSpeedDtc': string;
    /**
    * 
    */
    'feedbackSpeedFeedback': string;
    /**
    * 
    */
    'unixPathOnWindows': string;
    /**
    * Ограничение по IP адресам - FTP доступ.
    */
    'ftpIpfilter': string;
    /**
    * Ограничение по IP адресам - SSH доступ.
    */
    'sshIpfilter': string;
    /**
    * 
    */
    'l3dAuto': string;
    /**
    * 
    */
    'awstatsPrimaryDomain': string;
    /**
    * 
    */
    'sharepointMode': string;
    /**
    * 
    */
    'sharepointModePending': string;
    /**
    * 
    */
    'apacheGenericPoolPort': string;
    /**
    * 
    */
    'mongrelEnvironment': string;
    /**
    * 
    */
    'flagFree': string;
    /**
    * 
    */
    'rtmScanDate': string;
    /**
    * 
    */
    'analyzeAnalog': string;
    /**
    * Включен режим предоставления детализации процессорной нагрузки.
    */
    'cpuDetailsEnabled': string;
    /**
    * 
    */
    'contentModeratedStatus': string;
    /**
    * 
    */
    'contentModeratedDate': string;
    /**
    * 
    */
    'httpFrontendIp': string;
    /**
    * 
    */
    'httpFrontendIpTransition': string;
    /**
    * Дата последнего превышения процессорной нагрузки.
    */
    'cpuLimitExceededDate': string;
    /**
    * Признак сайта-конструктора.
    */
    'aufsTemplate': string;
    /**
    * 
    */
    'optionsAutolimit': string;
    /**
    * Версия ASP.NET, если отлична от 2.0.
    */
    'iisCreationCommands': string;
    /**
    * 
    */
    'iisCreationCommandsUnix': string;
    /**
    * 
    */
    'thumbDate': string;
    /**
    * 
    */
    'thumbFailed': string;
    /**
    * 
    */
    'backupStatDate': string;
    /**
    * Дата пофайловой резервной копии.
    */
    'backupDate': string;
    /**
    * 
    */
    'detectedPackages': string;
    /**
    * 
    */
    'statSitePower': string;
    /**
    * 
    */
    'smtpFrom': string;
    /**
    * 
    */
    'superBackupDate': string;
    /**
    * 
    */
    'backupDeltaStatDate': string;
    /**
    * Дата архивной резервной копии.
    */
    'backupDeltaDate': string;
    /**
    * Содержимое архивной резервной копии.
    */
    'backupDeltaDesc': string;
    /**
    * 
    */
    'altDocrootServer': string;
    /**
    * 
    */
    'altDocrootPath': string;
    /**
    * 
    */
    'altDocrootStatus': string;
    /**
    * 
    */
    'altDocrootStatusCnt': string;
    /**
    * 
    */
    'altDocrootStatusDate': string;
    /**
    * Последнее изменение привязок доменов для сайта.
    */
    'bindDtc': string;
    /**
    * 
    */
    'backupSpecialMode': string;
    /**
    * 
    */
    'sizeCheckProblem': string;
    /**
    * 
    */
    'wpbDomain': string;
    /**
    * Для сайта включен конструктор Parallels WPB.
    */
    'wpbUuid': string;
    /**
    * 
    */
    'wpbStatus': string;
    /**
    * 
    */
    'adminProtection': string;
    /**
    * 
    */
    'sizeComments': string;
    /**
    * 
    */
    'altDocrootSsdReq': string;
    /**
    * 
    */
    'mailLimit': string;
    /**
    * 
    */
    'mailAccept': string;
    /**
    * 
    */
    'mailDrop': string;
    /**
    * FTP/SSH/SCP/SFTP логин.
    */
    'ftpName': string;
    /**
    * FTP/SSH/SCP/SFTP пароль.
    */
    'ftpPwd': string;
}

export class InlineResponse2002 {
    /**
    * идентификатор аккаунта
    */
    'id': number;
    /**
    * логин
    */
    'name': string;
    /**
    * идентификатор сервера. Если равен или больше 10000, то это Postgres. Иначе MySQL
    */
    'server': string;
    /**
    * пароль
    */
    'pwd': string;
    /**
    * суффикс домена сервера
    */
    'urlSuffix': string;
}

export class InlineResponse2003 {
    /**
    * идентификатор домена
    */
    'id': number;
    /**
    * идентификатор связанной записи IIS
    */
    'iisId': number;
    /**
    * домен работает, если true
    */
    'online': boolean;
    /**
    * полное имя домена
    */
    'fullDomainName': string;
    /**
    * 
    */
    'fullDomainNameLocal': string;
    /**
    * 
    */
    'addr1': string;
    /**
    * зона домена
    */
    'zone': string;
}

export class InlineResponse2004 {
    /**
    * Дата последнего обновления домена
    */
    'dateUpdated': string;
    /**
    * Дата создания записи
    */
    'recordCreated': string;
    /**
    * 
    */
    'subjectContract': string;
    /**
    * 
    */
    'endDate': string;
    /**
    * Дата, до которой оплачен домен
    */
    'payedTill': string;
    /**
    * 
    */
    'objectState': string;
    /**
    * Имя домена
    */
    'domainAddr': string;
    /**
    * Сервера имён домена
    */
    'nservers': string;
    /**
    * Количество дней до окончания срока действия домена
    */
    'expiresCountdown': number;
}

export class InlineResponse2005 {
    /**
    * идентификатор псевдонима
    */
    'id': number;
    /**
    * почтовый ящик псевдонима
    */
    'mail': string;
    /**
    * имя псевдонима
    */
    'alias': string;
}

export class InlineResponse2006 {
    /**
    * идентификатор ящика
    */
    'id': number;
    /**
    * 
    */
    'status': number;
    /**
    * ящик работает, если true
    */
    'online': boolean;
    /**
    * полный адрес ящика
    */
    'mail': string;
    /**
    * имя пользователя для входа в Mercury
    */
    'mercuryUser': string;
    /**
    * пароль для входа в Mercury
    */
    'mercuryPwd': string;
    /**
    * текущий размер ящика
    */
    'sizeAmount': number;
    /**
    * количество файлов, занятых ящиком
    */
    'sizeFileCount': number;
    /**
    * 
    */
    'archivedCount': number;
    /**
    * адрес сервера для доступа к ящику по POP3
    */
    'serverPop3': string;
    /**
    * адрес сервера для доступа к ящику по SMTP
    */
    'serverSmtp': string;
    /**
    * адрес сервера Webmail для входа в ящик через браузер
    */
    'serverWebmail': string;
    /**
    * адрес сервера для доступа к ящику по IMAP
    */
    'serverImap': string;
    /**
    * 
    */
    'wm1': string;
    /**
    * 
    */
    'wm2': string;
}

export class InlineResponse2007 {
    /**
    * идентификатор аккаунта
    */
    'id': number;
    /**
    * логин
    */
    'name': string;
    /**
    * пароль
    */
    'pwd': string;
}

export class InlineResponse2008 {
    /**
    * идентификатор сайта
    */
    'id': number;
    /**
    * сайт работает нормально если true
    */
    'online': boolean;
    /**
    * идентификатор связанного аккаунта FTP
    */
    'ftpId': number;
    /**
    * идентификатор связанной записи DNS
    */
    'dnsId': number;
    /**
    * размер занятого места
    */
    'sizeAmount': number;
    /**
    * количество файлов
    */
    'sizeFileCount': number;
    /**
    * ограничение на количество файлов
    */
    'sizeFileCountLimit': number;
}

export class InlineResponse2009 {
    /**
    * идентификатор аккаунта
    */
    'id': number;
    /**
    * имя базы данных
    */
    'db': string;
    /**
    * адрес сервера
    */
    'server': string;
    /**
    * логин
    */
    'name': string;
    /**
    * пароль
    */
    'pwd': string;
}

export class _ {
    /**
    * Ограничение на количество почтовых ящиков. '-' означает отсутствие лимита.
    */
    'mail': string;
    /**
    * Ограничение на количество сайтов. '-' означает отсутствие лимита.
    */
    'website': string;
    /**
    * MySQL разрешен, если true.
    */
    'mysql': boolean;
    /**
    * Ограничение на размер дискового пространства. '-' означает отсутствие лимита.
    */
    'size': string;
    /**
    * MSSQL разрешен, если true.
    */
    'mssql': boolean;
    /**
    * CGI и PHP скрипты разрешены, если true.
    */
    'dynamicContent': boolean;
    /**
    * Функция exec() в PHP разрешена, если true.
    */
    'phpExec': boolean;
    /**
    * Ограничение на количество дополнительных FTP логинов. '-' означает отсутствие лимита.
    */
    'ftp2': string;
}


export interface Authentication {
    /**
    * Apply authentication settings to header and query params.
    */
    applyToRequest(requestOptions: request.Options): void;
}

export class HttpBasicAuth implements Authentication {
    public username: string;
    public password: string;
    applyToRequest(requestOptions: request.Options): void {
        requestOptions.auth = {
            username: this.username, password: this.password
        }
    }
}

export class ApiKeyAuth implements Authentication {
    public apiKey: string;

    constructor(private location: string, private paramName: string) {
    }

    applyToRequest(requestOptions: request.Options): void {
        if (this.location == "query") {
            (<any>requestOptions.qs)[this.paramName] = this.apiKey;
        } else if (this.location == "header") {
            requestOptions.headers[this.paramName] = this.apiKey;
        }
    }
}

export class OAuth implements Authentication {
    public accessToken: string;

    applyToRequest(requestOptions: request.Options): void {
        requestOptions.headers["Authorization"] = "Bearer " + this.accessToken;
    }
}

export class VoidAuth implements Authentication {
    public username: string;
    public password: string;
    applyToRequest(requestOptions: request.Options): void {
        // Do nothing
    }
}

export enum DefaultApiApiKeys {
}

export class DefaultApi {
    protected basePath = defaultBasePath;
    protected defaultHeaders : any = {};
    protected _useQuerystring : boolean = false;

    protected authentications = {
        'default': <Authentication>new VoidAuth(),
    }

    constructor(basePath?: string);
    constructor(basePathOrUsername: string, password?: string, basePath?: string) {
        if (password) {
            if (basePath) {
                this.basePath = basePath;
            }
        } else {
            if (basePathOrUsername) {
                this.basePath = basePathOrUsername
            }
        }
    }

    set useQuerystring(value: boolean) {
        this._useQuerystring = value;
    }

    public setApiKey(key: DefaultApiApiKeys, value: string) {
        this.authentications[DefaultApiApiKeys[key]].apiKey = value;
    }
    private extendObj<T1,T2>(objA: T1, objB: T2) {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                objA[key] = objB[key];
            }
        }
        return <T1&T2>objA;
    }
    /**
     * Аккаунт: баланс
     * Возвращает текущий баланс аккаунта
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public balanceGet (token_: string) : Promise<{ response: http.ClientResponse; body: number;  }> {
        const localVarPath = this.basePath + '/balance';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling balanceGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: number;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Аккаунт: баланс аккаунта лицензий
     * Возвращает текущий баланс аккаунта лицензий
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public balanceLicGet (token_: string) : Promise<{ response: http.ClientResponse; body: number;  }> {
        const localVarPath = this.basePath + '/balance.lic';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling balanceLicGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: number;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Информация по дебету аккаунта
     * Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public billingDebtGet (token_: string) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse200>;  }> {
        const localVarPath = this.basePath + '/billing/debt';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling billingDebtGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse200>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Информация об аккаунте
     * Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public billingInfoGet (token_: string) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse2001>;  }> {
        const localVarPath = this.basePath + '/billing/info';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling billingInfoGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse2001>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Получить ограничения аккаунта
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public billingLimitsGet (token_: string) : Promise<{ response: http.ClientResponse; body: _;  }> {
        const localVarPath = this.basePath + '/billing/limits';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling billingLimitsGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: _;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Информация по продлению доменов
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public dnsProlongListGet (token_: string) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse2004>;  }> {
        const localVarPath = this.basePath + '/dns/prolong/list';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling dnsProlongListGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse2004>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Создание почтового ящика
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param addEmail Адрес почтового ящика, который необходимо создать
     */
    public emailAddGet (token_: string, addEmail: string) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/email/add';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling emailAddGet.');
        }

        // verify required parameter 'addEmail' is not null or undefined
        if (addEmail === null || addEmail === undefined) {
            throw new Error('Required parameter addEmail was null or undefined when calling emailAddGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (addEmail !== undefined) {
            queryParameters['add_email'] = addEmail;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Удаление псевдонимов почтовых ящиков
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ Адрес почтового ящика, подлежащего удалению
     */
    public emailAliasDeleteGet (token_: string, key_: string) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/email/alias/delete';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling emailAliasDeleteGet.');
        }

        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling emailAliasDeleteGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (key_ !== undefined) {
            queryParameters['_key_'] = key_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Получить список псевдонимов почтовых ящиков
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public emailAliasListGet (token_: string) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse2005>;  }> {
        const localVarPath = this.basePath + '/email/alias/list';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling emailAliasListGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse2005>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Удаление почтового ящика
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ Адрес почтового ящика, подлежащего удалению
     */
    public emailDeleteGet (token_: string, key_: string) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/email/delete';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling emailDeleteGet.');
        }

        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling emailDeleteGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (key_ !== undefined) {
            queryParameters['_key_'] = key_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Получить список почтовых ящиков
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public emailListGet (token_: string) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse2006>;  }> {
        const localVarPath = this.basePath + '/email/list';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling emailListGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse2006>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Идентификатор последнего уведомления в аудите
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public updatesLastGet (token_: string) : Promise<{ response: http.ClientResponse; body: number;  }> {
        const localVarPath = this.basePath + '/updates/last';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling updatesLastGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: number;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Список записей аудита
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID первой записи для показа или 0 для показа всех записей
     */
    public updatesListGet (token_: string, key_: number) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse20010>;  }> {
        const localVarPath = this.basePath + '/updates/list';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling updatesListGet.');
        }

        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling updatesListGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (key_ !== undefined) {
            queryParameters['_key_'] = key_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse20010>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Удаление сайта
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID сайта, полученный из /website/list
     */
    public websiteDeleteGet (token_: string, key_: string) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/website/delete';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling websiteDeleteGet.');
        }

        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling websiteDeleteGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (key_ !== undefined) {
            queryParameters['_key_'] = key_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Список сайтов аккаунта
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public websiteListGet (token_: string) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse20014>;  }> {
        const localVarPath = this.basePath + '/website/list';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling websiteListGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse20014>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
}
export enum AuthAPIApiApiKeys {
}

export class AuthAPIApi {
    protected basePath = defaultBasePath;
    protected defaultHeaders : any = {};
    protected _useQuerystring : boolean = false;

    protected authentications = {
        'default': <Authentication>new VoidAuth(),
    }

    constructor(basePath?: string);
    constructor(basePathOrUsername: string, password?: string, basePath?: string) {
        if (password) {
            if (basePath) {
                this.basePath = basePath;
            }
        } else {
            if (basePathOrUsername) {
                this.basePath = basePathOrUsername
            }
        }
    }

    set useQuerystring(value: boolean) {
        this._useQuerystring = value;
    }

    public setApiKey(key: AuthAPIApiApiKeys, value: string) {
        this.authentications[AuthAPIApiApiKeys[key]].apiKey = value;
    }
    private extendObj<T1,T2>(objA: T1, objB: T2) {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                objA[key] = objB[key];
            }
        }
        return <T1&T2>objA;
    }
    /**
     * Получить ключ доступа
     * Возвращает ключ доступа, с которым в дальнейшем будут осуществляться всё взаимодействие с API  (параметр &#39;token&#39;). Для вычисления значения параметра &#39;response&#39; необходимо получить представленную в hex MD5-сумму от  объединения строк пароля пользователя, полученной соли и символа переноса строки. Псевдокод операции:  hex(md5(password&amp;nbsp;+&amp;nbsp;salt&amp;nbsp;+&amp;nbsp;&#39;\\n&#39;))
     * @param login Имя пользователя
     * @param salt Соль (см. /auth/start)
     * @param response Вычисленный хэш
     */
    public authLoginPost (login: string, salt: string, response: string) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/auth/login';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'login' is not null or undefined
        if (login === null || login === undefined) {
            throw new Error('Required parameter login was null or undefined when calling authLoginPost.');
        }

        // verify required parameter 'salt' is not null or undefined
        if (salt === null || salt === undefined) {
            throw new Error('Required parameter salt was null or undefined when calling authLoginPost.');
        }

        // verify required parameter 'response' is not null or undefined
        if (response === null || response === undefined) {
            throw new Error('Required parameter response was null or undefined when calling authLoginPost.');
        }

        if (login !== undefined) {
            queryParameters['login'] = login;
        }

        if (salt !== undefined) {
            queryParameters['salt'] = salt;
        }

        if (response !== undefined) {
            queryParameters['response'] = response;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'POST',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Получить соль
     * Возвращает соль для авторизации. Это первый этап идентификации пользователя. Затем соль используется  во втором, окончательном этапе авторизации, в запросе /auth/login. Запрос не требует дополнительных параметров.
     * @param login Имя пользователя
     */
    public authStartGet (login: string) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/auth/start';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'login' is not null or undefined
        if (login === null || login === undefined) {
            throw new Error('Required parameter login was null or undefined when calling authStartGet.');
        }

        if (login !== undefined) {
            queryParameters['login'] = login;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
}
export enum DNSApiApiKeys {
}

export class DNSApi {
    protected basePath = defaultBasePath;
    protected defaultHeaders : any = {};
    protected _useQuerystring : boolean = false;

    protected authentications = {
        'default': <Authentication>new VoidAuth(),
    }

    constructor(basePath?: string);
    constructor(basePathOrUsername: string, password?: string, basePath?: string) {
        if (password) {
            if (basePath) {
                this.basePath = basePath;
            }
        } else {
            if (basePathOrUsername) {
                this.basePath = basePathOrUsername
            }
        }
    }

    set useQuerystring(value: boolean) {
        this._useQuerystring = value;
    }

    public setApiKey(key: DNSApiApiKeys, value: string) {
        this.authentications[DNSApiApiKeys[key]].apiKey = value;
    }
    private extendObj<T1,T2>(objA: T1, objB: T2) {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                objA[key] = objB[key];
            }
        }
        return <T1&T2>objA;
    }
    /**
     * Создание записи домена
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param addDnsZone зона, которую необходимо создать
     * @param addDnsRecord 
     * @param iisSiteForDns ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку
     * @param bindOnly 
     */
    public dnsAddGet (token_: string, addDnsZone: string, addDnsRecord?: string, iisSiteForDns?: string, bindOnly?: boolean) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/dns/add';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling dnsAddGet.');
        }

        // verify required parameter 'addDnsZone' is not null or undefined
        if (addDnsZone === null || addDnsZone === undefined) {
            throw new Error('Required parameter addDnsZone was null or undefined when calling dnsAddGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (addDnsZone !== undefined) {
            queryParameters['add_dns_zone'] = addDnsZone;
        }

        if (addDnsRecord !== undefined) {
            queryParameters['add_dns_record'] = addDnsRecord;
        }

        if (iisSiteForDns !== undefined) {
            queryParameters['iis_site_for_dns'] = iisSiteForDns;
        }

        if (bindOnly !== undefined) {
            queryParameters['bind_only'] = bindOnly;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Привязка одного домена к другому
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из списка /dns/list
     * @param bindTo домен, к которому необходимо сделать привязку
     */
    public dnsBindGet (token_: string, key_: number, bindTo?: string) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/dns/bind';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling dnsBindGet.');
        }

        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling dnsBindGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (key_ !== undefined) {
            queryParameters['_key_'] = key_;
        }

        if (bindTo !== undefined) {
            queryParameters['bind_to'] = bindTo;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Получить список доменных имён
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public dnsListGet (token_: string) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse2003>;  }> {
        const localVarPath = this.basePath + '/dns/list';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling dnsListGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse2003>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Информация по продлению доменов
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public dnsProlongListGet (token_: string) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse2004>;  }> {
        const localVarPath = this.basePath + '/dns/prolong/list';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling dnsProlongListGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse2004>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Редактирование \&quot;сырой\&quot; зоны
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из /dns/list
     * @param sDel Значение &#39;1&#39; сообщает, что запись необходимо удалить
     * @param sAdd Значение &#39;1&#39; сообщает, что запись необходимо создать
     * @param dnsType Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV
     * @param dnsName Имя записи, либо &#39;@&#39; для корневой
     * @param dnsValue Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)
     */
    public dnsRawGet (token_: string, key_: number, sDel: number, sAdd: number, dnsType: string, dnsName: string, dnsValue: string) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/dns/raw';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling dnsRawGet.');
        }

        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling dnsRawGet.');
        }

        // verify required parameter 'sDel' is not null or undefined
        if (sDel === null || sDel === undefined) {
            throw new Error('Required parameter sDel was null or undefined when calling dnsRawGet.');
        }

        // verify required parameter 'sAdd' is not null or undefined
        if (sAdd === null || sAdd === undefined) {
            throw new Error('Required parameter sAdd was null or undefined when calling dnsRawGet.');
        }

        // verify required parameter 'dnsType' is not null or undefined
        if (dnsType === null || dnsType === undefined) {
            throw new Error('Required parameter dnsType was null or undefined when calling dnsRawGet.');
        }

        // verify required parameter 'dnsName' is not null or undefined
        if (dnsName === null || dnsName === undefined) {
            throw new Error('Required parameter dnsName was null or undefined when calling dnsRawGet.');
        }

        // verify required parameter 'dnsValue' is not null or undefined
        if (dnsValue === null || dnsValue === undefined) {
            throw new Error('Required parameter dnsValue was null or undefined when calling dnsRawGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (key_ !== undefined) {
            queryParameters['_key_'] = key_;
        }

        if (sDel !== undefined) {
            queryParameters['s_del'] = sDel;
        }

        if (sAdd !== undefined) {
            queryParameters['s_add'] = sAdd;
        }

        if (dnsType !== undefined) {
            queryParameters['dns_type'] = dnsType;
        }

        if (dnsName !== undefined) {
            queryParameters['dns_name'] = dnsName;
        }

        if (dnsValue !== undefined) {
            queryParameters['dns_value'] = dnsValue;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Редактировать DNS-зону
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из /dns/list
     * @param managedMx Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить
     * @param updManagedMx Значение &#39;1&#39; подтверждает операцию
     */
    public dnsRawManagedmxGet (token_: string, key_: number, managedMx: number, updManagedMx: number) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/dns/raw/managedmx';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling dnsRawManagedmxGet.');
        }

        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling dnsRawManagedmxGet.');
        }

        // verify required parameter 'managedMx' is not null or undefined
        if (managedMx === null || managedMx === undefined) {
            throw new Error('Required parameter managedMx was null or undefined when calling dnsRawManagedmxGet.');
        }

        // verify required parameter 'updManagedMx' is not null or undefined
        if (updManagedMx === null || updManagedMx === undefined) {
            throw new Error('Required parameter updManagedMx was null or undefined when calling dnsRawManagedmxGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (key_ !== undefined) {
            queryParameters['_key_'] = key_;
        }

        if (managedMx !== undefined) {
            queryParameters['managed_mx'] = managedMx;
        }

        if (updManagedMx !== undefined) {
            queryParameters['upd_managed_mx'] = updManagedMx;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
}
export enum HostingftpAPIApiApiKeys {
}

export class HostingftpAPIApi {
    protected basePath = defaultBasePath;
    protected defaultHeaders : any = {};
    protected _useQuerystring : boolean = false;

    protected authentications = {
        'default': <Authentication>new VoidAuth(),
    }

    constructor(basePath?: string);
    constructor(basePathOrUsername: string, password?: string, basePath?: string) {
        if (password) {
            if (basePath) {
                this.basePath = basePath;
            }
        } else {
            if (basePathOrUsername) {
                this.basePath = basePathOrUsername
            }
        }
    }

    set useQuerystring(value: boolean) {
        this._useQuerystring = value;
    }

    public setApiKey(key: HostingftpAPIApiApiKeys, value: string) {
        this.authentications[HostingftpAPIApiApiKeys[key]].apiKey = value;
    }
    private extendObj<T1,T2>(objA: T1, objB: T2) {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                objA[key] = objB[key];
            }
        }
        return <T1&T2>objA;
    }
    /**
     * Получить список зарегистрированных аккаунтов FTP
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public ftpListGet (token_: string) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse2007>;  }> {
        const localVarPath = this.basePath + '/ftp/list';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling ftpListGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse2007>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
}
export enum HostingiisAPIApiApiKeys {
}

export class HostingiisAPIApi {
    protected basePath = defaultBasePath;
    protected defaultHeaders : any = {};
    protected _useQuerystring : boolean = false;

    protected authentications = {
        'default': <Authentication>new VoidAuth(),
    }

    constructor(basePath?: string);
    constructor(basePathOrUsername: string, password?: string, basePath?: string) {
        if (password) {
            if (basePath) {
                this.basePath = basePath;
            }
        } else {
            if (basePathOrUsername) {
                this.basePath = basePathOrUsername
            }
        }
    }

    set useQuerystring(value: boolean) {
        this._useQuerystring = value;
    }

    public setApiKey(key: HostingiisAPIApiApiKeys, value: string) {
        this.authentications[HostingiisAPIApiApiKeys[key]].apiKey = value;
    }
    private extendObj<T1,T2>(objA: T1, objB: T2) {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                objA[key] = objB[key];
            }
        }
        return <T1&T2>objA;
    }
    /**
     * Список сайтов IIS
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public iisListGet (token_: string) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse2008>;  }> {
        const localVarPath = this.basePath + '/iis/list';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling iisListGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse2008>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
}
export enum MicrosoftSQLServerApiApiKeys {
}

export class MicrosoftSQLServerApi {
    protected basePath = defaultBasePath;
    protected defaultHeaders : any = {};
    protected _useQuerystring : boolean = false;

    protected authentications = {
        'default': <Authentication>new VoidAuth(),
    }

    constructor(basePath?: string);
    constructor(basePathOrUsername: string, password?: string, basePath?: string) {
        if (password) {
            if (basePath) {
                this.basePath = basePath;
            }
        } else {
            if (basePathOrUsername) {
                this.basePath = basePathOrUsername
            }
        }
    }

    set useQuerystring(value: boolean) {
        this._useQuerystring = value;
    }

    public setApiKey(key: MicrosoftSQLServerApiApiKeys, value: string) {
        this.authentications[MicrosoftSQLServerApiApiKeys[key]].apiKey = value;
    }
    private extendObj<T1,T2>(objA: T1, objB: T2) {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                objA[key] = objB[key];
            }
        }
        return <T1&T2>objA;
    }
    /**
     * Получить список аккаунтов в MSSQL
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public mssqlListGet (token_: string) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse2009>;  }> {
        const localVarPath = this.basePath + '/mssql/list';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling mssqlListGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse2009>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
}
export enum MySQLPostgresApiApiKeys {
}

export class MySQLPostgresApi {
    protected basePath = defaultBasePath;
    protected defaultHeaders : any = {};
    protected _useQuerystring : boolean = false;

    protected authentications = {
        'default': <Authentication>new VoidAuth(),
    }

    constructor(basePath?: string);
    constructor(basePathOrUsername: string, password?: string, basePath?: string) {
        if (password) {
            if (basePath) {
                this.basePath = basePath;
            }
        } else {
            if (basePathOrUsername) {
                this.basePath = basePathOrUsername
            }
        }
    }

    set useQuerystring(value: boolean) {
        this._useQuerystring = value;
    }

    public setApiKey(key: MySQLPostgresApiApiKeys, value: string) {
        this.authentications[MySQLPostgresApiApiKeys[key]].apiKey = value;
    }
    private extendObj<T1,T2>(objA: T1, objB: T2) {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                objA[key] = objB[key];
            }
        }
        return <T1&T2>objA;
    }
    /**
     * Список аккаунтов в базах данных UNIX
     * Возвращает список зарегистрированных аккаунтов в базах данных MySQL и Postgres. Для вычисления имени домена необходимо объединить имя базы данных,   идентификатор сервера и суффикс (поле url_suffix). Например, если ID сервера равен 123 (значит это MySQL — см. описание поля &#39;server&#39; в ответе), а суффикс равен &#39;1gb.ru&#39;, то домен   для доступа будет равен &#39;mysql123.1gb.ru&#39;.
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public databaseListGet (token_: string) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse2002>;  }> {
        const localVarPath = this.basePath + '/database/list';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling databaseListGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse2002>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
}
export enum VDSHyperVOpenVZApiApiKeys {
}

export class VDSHyperVOpenVZApi {
    protected basePath = defaultBasePath;
    protected defaultHeaders : any = {};
    protected _useQuerystring : boolean = false;

    protected authentications = {
        'default': <Authentication>new VoidAuth(),
    }

    constructor(basePath?: string);
    constructor(basePathOrUsername: string, password?: string, basePath?: string) {
        if (password) {
            if (basePath) {
                this.basePath = basePath;
            }
        } else {
            if (basePathOrUsername) {
                this.basePath = basePathOrUsername
            }
        }
    }

    set useQuerystring(value: boolean) {
        this._useQuerystring = value;
    }

    public setApiKey(key: VDSHyperVOpenVZApiApiKeys, value: string) {
        this.authentications[VDSHyperVOpenVZApiApiKeys[key]].apiKey = value;
    }
    private extendObj<T1,T2>(objA: T1, objB: T2) {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                objA[key] = objB[key];
            }
        }
        return <T1&T2>objA;
    }
    /**
     * Изменение параметров VDS
     * Изменение параметров уже существующего VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param type Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39;
     * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
     * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30
     * @param crHvcpu Количество ядер CPU. По умолчанию 2
     * @param template Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list
     * @param forceMemo 
     * @param hv1gbPanelVersion 
     * @param panelInstall Необходимо ли установить панель 1Gb на VDS
     * @param crSsd1 Создать всю систему на SSD
     * @param crHvAllSystem Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)
     */
    public vdsCreateGet (token_: string, type?: string, crHvmem?: number, crHvdsk?: number, crHvcpu?: number, template?: string, forceMemo?: string, hv1gbPanelVersion?: string, panelInstall?: boolean, crSsd1?: boolean, crHvAllSystem?: boolean) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/vds/create';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling vdsCreateGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (type !== undefined) {
            queryParameters['type'] = type;
        }

        if (crHvmem !== undefined) {
            queryParameters['cr_hvmem'] = crHvmem;
        }

        if (crHvdsk !== undefined) {
            queryParameters['cr_hvdsk'] = crHvdsk;
        }

        if (crHvcpu !== undefined) {
            queryParameters['cr_hvcpu'] = crHvcpu;
        }

        if (template !== undefined) {
            queryParameters['template'] = template;
        }

        if (forceMemo !== undefined) {
            queryParameters['force_memo'] = forceMemo;
        }

        if (hv1gbPanelVersion !== undefined) {
            queryParameters['hv_1gb_panel_version'] = hv1gbPanelVersion;
        }

        if (panelInstall !== undefined) {
            queryParameters['panel_install'] = panelInstall;
        }

        if (crSsd1 !== undefined) {
            queryParameters['cr_ssd1'] = crSsd1;
        }

        if (crHvAllSystem !== undefined) {
            queryParameters['cr_hv_all_system'] = crHvAllSystem;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Удаление VDS
     * Предоставляет функционал для удаления VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     * @param forceCritical Если true, VDS будет удален срочно
     */
    public vdsDeleteGet (token_: string, key_: number, forceCritical?: boolean) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/vds/delete';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling vdsDeleteGet.');
        }

        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling vdsDeleteGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (key_ !== undefined) {
            queryParameters['_key_'] = key_;
        }

        if (forceCritical !== undefined) {
            queryParameters['force_critical'] = forceCritical;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Добавление IP на VDS
     * Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     */
    public vdsIpAddGet (token_: string, key_: number) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/vds/ip/add';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling vdsIpAddGet.');
        }

        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling vdsIpAddGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (key_ !== undefined) {
            queryParameters['_key_'] = key_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Удаление IP с VDS
     * Этот вызов позволяет отвязать IP адрес от VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     * @param delIp IP адрес, который необходимо удалить
     */
    public vdsIpDeleteGet (token_: string, key_: number, delIp: string) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/vds/ip/delete';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling vdsIpDeleteGet.');
        }

        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling vdsIpDeleteGet.');
        }

        // verify required parameter 'delIp' is not null or undefined
        if (delIp === null || delIp === undefined) {
            throw new Error('Required parameter delIp was null or undefined when calling vdsIpDeleteGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (key_ !== undefined) {
            queryParameters['_key_'] = key_;
        }

        if (delIp !== undefined) {
            queryParameters['del_ip'] = delIp;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Список IP-адресов виртуальных серверов
     * Список IP-адресов виртуальных серверов
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     */
    public vdsIpListGet (token_: string, key_?: number) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse20011>;  }> {
        const localVarPath = this.basePath + '/vds/ip/list';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling vdsIpListGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (key_ !== undefined) {
            queryParameters['_key_'] = key_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse20011>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Список виртуальных серверов
     * Позволяет получить список виртуальных серверов
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS
     */
    public vdsListGet (token_: string, key_?: number) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse20012>;  }> {
        const localVarPath = this.basePath + '/vds/list';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling vdsListGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (key_ !== undefined) {
            queryParameters['_key_'] = key_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse20012>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Перезагрузка VDS
     * Предоставляет функционал для перезагрузки VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     */
    public vdsRebootGet (token_: string, key_: number) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/vds/reboot';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling vdsRebootGet.');
        }

        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling vdsRebootGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (key_ !== undefined) {
            queryParameters['_key_'] = key_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Список шаблонов виртуальных серверов
     * Позволяет получить список шаблонов виртуальных серверов
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public vdsTemplatesListGet (token_: string) : Promise<{ response: http.ClientResponse; body: Array<InlineResponse20013>;  }> {
        const localVarPath = this.basePath + '/vds/templates-list';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling vdsTemplatesListGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: Array<InlineResponse20013>;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
    /**
     * Создание VDS
     * Создание новых VDS с произвольными характеристиками
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
     * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30
     * @param crHvcpu Количество ядер CPU. По умолчанию 2
     */
    public vdsUpdateGet (token_: string, key_: number, crHvmem?: number, crHvdsk?: number, crHvcpu?: number) : Promise<{ response: http.ClientResponse; body: string;  }> {
        const localVarPath = this.basePath + '/vds/update';
        let queryParameters: any = {};
        let headerParams: any = this.extendObj({}, this.defaultHeaders);
        let formParams: any = {};


        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling vdsUpdateGet.');
        }

        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling vdsUpdateGet.');
        }

        if (token_ !== undefined) {
            queryParameters['_token_'] = token_;
        }

        if (key_ !== undefined) {
            queryParameters['_key_'] = key_;
        }

        if (crHvmem !== undefined) {
            queryParameters['cr_hvmem'] = crHvmem;
        }

        if (crHvdsk !== undefined) {
            queryParameters['cr_hvdsk'] = crHvdsk;
        }

        if (crHvcpu !== undefined) {
            queryParameters['cr_hvcpu'] = crHvcpu;
        }

        let useFormData = false;

        let requestOptions: request.Options = {
            method: 'GET',
            qs: queryParameters,
            headers: headerParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        this.authentications.default.applyToRequest(requestOptions);

        if (Object.keys(formParams).length) {
            if (useFormData) {
                (<any>requestOptions).formData = formParams;
            } else {
                requestOptions.form = formParams;
            }
        }
        return new Promise<{ response: http.ClientResponse; body: string;  }>((resolve, reject) => {
            request(requestOptions, (error, response, body) => {
                if (error) {
                    reject(error);
                } else {
                    if (response.statusCode >= 200 && response.statusCode <= 299) {
                        resolve({ response: response, body: body });
                    } else {
                        reject({ response: response, body: body });
                    }
                }
            });
        });
    }
}
